package io.zipcoder;

public class StringsAndThings {

    /**
     * Given a string, count the number of words ending in 'y' or 'z' -- so the 'y' in "heavy" and the 'z' in "fez" count,
     * but not the 'y' in "yellow" (not case sensitive). We'll say that a y or z is at the end of a word if there is not an alphabetic
     * letter immediately following it. (Note: Character.isLetter(char) tests if a char is an alphabetic letter.)
     * example : countYZ("fez day"); // Should return 2
     *           countYZ("day fez"); // Should return 2
     *           countYZ("day fyyyz"); // Should return 2
     */
    public Integer countYZ(String input)
    {
        String[] tempArray = input.split(" "); Integer count = 0;

        for (int i = 0; i < tempArray.length; i++)
        {
            if (tempArray[i].endsWith("y") || tempArray[i].endsWith("z")) { count ++; }
        }
        return count;
    }

    /**
     * Given two strings, base and remove, return a version of the base string where all instances of the remove string have
     * been removed (not case sensitive). You may assume that the remove string is length 1 or more.
     * Remove only non-overlapping instances, so with "xxx" removing "xx" leaves "x".
     *
     * example : withoutString("Hello there", "llo") // Should return "He there"
     *           withoutString("Hello there", "e") //  Should return "Hllo thr"
     *           withoutString("Hello there", "x") // Should return "Hello there"
     */
    public String withoutString(String base, String remove){
        String result = ""; int wordToRemoveLength = remove.length();
//        for (int i = 0; i < base.length() - wordToRemoveLength; i++) {
//            if (!base.substring(i, wordToRemoveLength + i).equalsIgnoreCase(remove)) {
//                result += base.substring(i);
//            }
//        }
        result = base.replace(remove, "");
        return result;
    }

    /**
     * Given a string, return true if the number of appearances of "is" anywhere in the string is equal
     * to the number of appearances of "not" anywhere in the string (case sensitive)
     *
     * example : equalIsNot("This is not")  // Should return false
     *           equalIsNot("This is notnot") // Should return true
     *           equalIsNot("noisxxnotyynotxisi") // Should return true
     */
    public Boolean equalIsNot(String input){
        boolean isEqual = false; char[] chars = input.toCharArray(); int isCount = 0, notCount = 0;

        for (int i = 0; i < chars.length - 1; i++)
        {
            if (chars[i] == 'i' && chars[i+1] == 's') { isCount ++; }
            if (chars[i] == 'n' && chars[i+1] == 'o' && chars[i+2] == 't') { notCount ++; }
        }

        isEqual = isCount == notCount; return isEqual;
    }

    /**
     * We'll say that a lowercase 'g' in a string is "happy" if there is another 'g' immediately to its left or right.
     * Return true if all the g's in the given string are happy.
     * example : gHappy("xxggxx") // Should return  true
     *           gHappy("xxgxx") // Should return  false
     *           gHappy("xxggyygxx") // Should return  false
     */
    public Boolean gIsHappy(String input) {
        boolean isHappy = false; char[] chars = input.toCharArray(); int occurence = 0, happyG = 0;

        for (int i = 1; i < chars.length - 1; i++)
        {
            if (chars[i] == Character.toLowerCase('g')) { occurence ++;
            if (chars[i-1] == Character.toLowerCase('g') || chars[i+1] == Character.toLowerCase('g')) { happyG ++; }}
        }

        isHappy = occurence == happyG; return isHappy;
    }


    /**
     * We'll say that a "triple" in a string is a char appearing three times in a row.
     * Return the number of triples in the given string. The triples may overlap.
     * example :  countTriple("abcXXXabc") // Should return 1
     *            countTriple("xxxabyyyycd") // Should return 3
     *            countTriple("a") // Should return 0
     */
    public Integer countTriple(String input)
    {
        char[] chars = input.toCharArray(); int tripleCount = 0;

        for (int i = 1; i < chars.length - 1; i++) {
            if (chars[i] == chars[i+1] && chars[i] == chars[i-1]) { tripleCount ++; } }

        return tripleCount;
    }
}
